// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe)
#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>  
#include <iostream>
#include "hilf.h"
#include "vector2.h"
#include "graphik.h"
#include "interpolation.h"

using namespace std;

// Newton-Interpolation
int main()
{ 
  int i,n,m;
  double a,b,h,t;
  double* w;
  double* z;
  double* u;
  double* x;
  double* y;
  cout <<"Groesse?:"<<endl;
  cin >> n;
  x=(double*)malloc(n*sizeof(double)); 
  y=(double*)malloc(n*sizeof(double));   
  u=(double*)malloc(n*sizeof(double));   
  cout <<"Punkte?"<<endl;
  for (i=0;i<n;i++)
      {
	cin >> x[i];
       }
  cout <<"Werte?"<<endl;
  for (i=0;i<n;i++)
       {
          cin >> y[i];
       } 
  AitkenNeville(n,x,y,u);
  cout <<"Zerlegungskoeffzienten"<<endl;
  ausgabe(u,n);
  
  // Plot
  cout <<"Aufloesung?:"<<endl;
  cin >> m;
  cout <<"Punkte min/max?"<<endl;
  cin >> a >> b;
  h=(b-a)/double(m);
  z=(double*)malloc((m+1)*sizeof(double));   
  w=(double*)malloc((m+1)*sizeof(double));   
  for (i=0;i<=m;i++)
      {
	z[i]=a+i*h;
        horner(z[i],u,x,n,&t);
        w[i]=t;
      }
  PlotResults1D(z,w,m+1);
  free(x);
  free(y);
  free(u);
  free(w);
  free(z);
  return 0;
}
